/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TWebSessionstate.TWebSessionstatePath;
import de.ship.db.tables.records.TWebApplicationRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TWebApplication extends TableImpl<TWebApplicationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_web_application</code>
     */
    public static final TWebApplication T_WEB_APPLICATION = new TWebApplication();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TWebApplicationRecord> getRecordType() {
        return TWebApplicationRecord.class;
    }

    /**
     * The column <code>common_dd.t_web_application.lastchange</code>.
     */
    public final TableField<TWebApplicationRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_web_application.pk</code>. unique id of
     * application
     */
    public final TableField<TWebApplicationRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id of application");

    /**
     * The column <code>common_dd.t_web_application.name</code>. application
     * name
     */
    public final TableField<TWebApplicationRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "application name");

    private TWebApplication(Name alias, Table<TWebApplicationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TWebApplication(Name alias, Table<TWebApplicationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_web_application</code> table
     * reference
     */
    public TWebApplication(String alias) {
        this(DSL.name(alias), T_WEB_APPLICATION);
    }

    /**
     * Create an aliased <code>common_dd.t_web_application</code> table
     * reference
     */
    public TWebApplication(Name alias) {
        this(alias, T_WEB_APPLICATION);
    }

    /**
     * Create a <code>common_dd.t_web_application</code> table reference
     */
    public TWebApplication() {
        this(DSL.name("t_web_application"), null);
    }

    public <O extends Record> TWebApplication(Table<O> path, ForeignKey<O, TWebApplicationRecord> childPath, InverseForeignKey<O, TWebApplicationRecord> parentPath) {
        super(path, childPath, parentPath, T_WEB_APPLICATION);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TWebApplicationPath extends TWebApplication implements Path<TWebApplicationRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TWebApplicationPath(Table<O> path, ForeignKey<O, TWebApplicationRecord> childPath, InverseForeignKey<O, TWebApplicationRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TWebApplicationPath(Name alias, Table<TWebApplicationRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TWebApplicationPath as(String alias) {
            return new TWebApplicationPath(DSL.name(alias), this);
        }

        @Override
        public TWebApplicationPath as(Name alias) {
            return new TWebApplicationPath(alias, this);
        }

        @Override
        public TWebApplicationPath as(Table<?> alias) {
            return new TWebApplicationPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TWebApplicationRecord, Integer> getIdentity() {
        return (Identity<TWebApplicationRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TWebApplicationRecord> getPrimaryKey() {
        return Keys.PK_WEB_APPLICATION;
    }

    private transient TWebSessionstatePath _tWebSessionstate;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_web_sessionstate</code> table
     */
    public TWebSessionstatePath tWebSessionstate() {
        if (_tWebSessionstate == null)
            _tWebSessionstate = new TWebSessionstatePath(this, null, Keys.T_WEB_SESSIONSTATE__FK_WEB_SESSIONSTATE_APP.getInverseKey());

        return _tWebSessionstate;
    }

    @Override
    public TWebApplication as(String alias) {
        return new TWebApplication(DSL.name(alias), this);
    }

    @Override
    public TWebApplication as(Name alias) {
        return new TWebApplication(alias, this);
    }

    @Override
    public TWebApplication as(Table<?> alias) {
        return new TWebApplication(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TWebApplication rename(String name) {
        return new TWebApplication(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TWebApplication rename(Name name) {
        return new TWebApplication(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TWebApplication rename(Table<?> name) {
        return new TWebApplication(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebApplication where(Condition condition) {
        return new TWebApplication(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebApplication where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebApplication where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebApplication where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebApplication where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebApplication where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebApplication where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebApplication where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebApplication whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebApplication whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
